Gecode::BoolExpr::Node Class Reference

Node for Boolean expression More...

## Public Member Functions

| Node (void)
| Default constructor.
| ~Node (void)
| Destructor.
bool | decrement (void)
| Decrement reference count and possibly free memory.

## Static Public Member Functions

static void * | operator new (size_t size)
| Memory management.
static void | operator delete (void *p, size_t size)
| Memory management.

## Public Attributes

unsigned int | use
| Nodes are reference counted.
int | same
| Number of variables in subtree with same type (for AND and OR).
NodeType | t
| Type of expression.
Node * | l
| Subexpressions.
Node * | r
BoolVar | x
| Possibly a variable.
LinIntRel | rl
| Possibly a reified linear relation.
LinFloatRel | rfl
| Possibly a reified float linear relation.
SetRel | rs
| Possibly a reified set relation.
Misc * | m
| Possibly a misc Boolean expression.

## Detailed Description

Node for Boolean expression

Definition at line 43 of file bool-expr.cpp.

## Constructor & Destructor Documentation

## Node()

Gecode::BoolExpr::Node::Node | ( | void |  | ) |

Default constructor.

Definition at line 86 of file bool-expr.cpp.

## ~Node()

Gecode::BoolExpr::Node::~Node | ( | void |  | ) |

Destructor.

Definition at line 89 of file bool-expr.cpp.

## Member Function Documentation

## decrement()

bool Gecode::BoolExpr::Node::decrement | ( | void |  | ) |

Decrement reference count and possibly free memory.

Definition at line 103 of file bool-expr.cpp.

## operator new()

void * Gecode::BoolExpr::Node::operator new | ( | size_t | size | ) |

static

Memory management.

Definition at line 94 of file bool-expr.cpp.

## operator delete()

void Gecode::BoolExpr::Node::operator delete | ( | void * | p,
|  | size_t | size )

static

Memory management.

Definition at line 98 of file bool-expr.cpp.

## Member Data Documentation

## use

unsigned int Gecode::BoolExpr::Node::use

Nodes are reference counted.

Definition at line 46 of file bool-expr.cpp.

## same

int Gecode::BoolExpr::Node::same

Number of variables in subtree with same type (for AND and OR).

Definition at line 48 of file bool-expr.cpp.

## t

NodeType Gecode::BoolExpr::Node::t

Type of expression.

Definition at line 50 of file bool-expr.cpp.

## l

Node* Gecode::BoolExpr::Node::l

Subexpressions.

Definition at line 52 of file bool-expr.cpp.

## r

Node * Gecode::BoolExpr::Node::r

Definition at line 52 of file bool-expr.cpp.

## x

BoolVar Gecode::BoolExpr::Node::x

Possibly a variable.

Definition at line 54 of file bool-expr.cpp.

## rl

LinIntRel Gecode::BoolExpr::Node::rl

Possibly a reified linear relation.

Definition at line 56 of file bool-expr.cpp.

## rfl

LinFloatRel Gecode::BoolExpr::Node::rfl

Possibly a reified float linear relation.

Definition at line 59 of file bool-expr.cpp.

## rs

SetRel Gecode::BoolExpr::Node::rs

Possibly a reified set relation.

Definition at line 63 of file bool-expr.cpp.

## m

Misc* Gecode::BoolExpr::Node::m

Possibly a misc Boolean expression.

Definition at line 66 of file bool-expr.cpp.

The documentation for this class was generated from the following file:

- gecode/minimodel/bool-expr.cpp